import type { ComponentThis, BaseProps } from "./types";
import { InternalComponent } from "./internal";
export declare type ContextProviderProps<T = unknown> = BaseProps & {
    value: T;
};
export declare type ContextProvider<T = unknown> = InternalComponent<ContextProviderProps<T>>;
export declare type Context<T = unknown> = {
    Provider: ContextProvider<T>;
    for(componentThis: ComponentThis): T;
};
export declare type CreateContextOptions<T> = {
    fallback?: T;
    description?: string;
};
export declare function createContext<T>(options: CreateContextOptions<T>): Context<T>;
