import type { ComponentChildren, CustomElementsHTML, IntrinsicElementsHTML, IntrinsicElementsSVG } from "./types";
export * from "./createContext";
export * from "./createElement";
export * from "./domUtils";
export * from "./jsx-runtime";
export * from "./ErrorBoundary";
export * from "./types";
export interface TsxConfig {
    [s: string]: boolean;
}
declare type IfTsxConfig<T extends string, TIF, TELSE> = TsxConfig[T] extends false ? TELSE : TIF;
declare type IntrinsicElementsCombined = IfTsxConfig<"html", IntrinsicElementsHTML, unknown> & IfTsxConfig<"svg", IntrinsicElementsSVG, unknown>;
declare global {
    namespace JSX {
        type Element = ComponentChildren;
        interface ElementAttributesProperty {
            props: unknown;
        }
        interface ElementChildrenAttribute {
            children: ComponentChildren;
        }
        interface IntrinsicElements extends IntrinsicElementsCombined, CustomElementsHTML {
        }
    }
}
