import type { HTMLAttributes, SVGAttributes, StyleAttributes } from "tsx-dom-types";
export declare type VNode = (document: Document, thisArg: ComponentThis) => Promise<HTMLElement | SVGElement | DocumentFragment | Text>;
export interface BaseProps {
    children?: ComponentChildren;
}
export interface HTMLComponentProps extends BaseProps {
    dangerouslySetInnerHTML?: string;
    tsxTag?: keyof HTMLElementTagNameMap | keyof SVGElementTagNameMap;
}
export interface ComponentThis {
    abortSignal: AbortSignal;
    withAbortSignal<T>(promise: Promise<T>): Promise<T>;
    [s: symbol]: unknown;
}
export declare type Component<T = BaseProps> = (this: ComponentThis, props: T) => ComponentChildren;
export declare type ComponentAttributes = {
    [s: string]: string | number | boolean | StyleAttributes;
};
export declare type ComponentChild = VNode | string | number | false | undefined | null;
export declare type ComponentChildren = ComponentChild | ComponentChildren[] | Promise<ComponentChild | ComponentChildren[]>;
export interface CustomElementsHTML {
}
export declare type SVGAndHTMLElementKeys = keyof SVGElementTagNameMap & keyof HTMLElementTagNameMap;
export declare type SVGOnlyElementKeys = Exclude<keyof SVGElementTagNameMap, SVGAndHTMLElementKeys>;
export declare type IntrinsicElementsHTML = {
    [TKey in keyof HTMLElementTagNameMap]?: HTMLAttributes & HTMLComponentProps;
};
export declare type IntrinsicElementsSVG = {
    [TKey in SVGOnlyElementKeys]?: SVGAttributes & HTMLComponentProps;
};
